//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed 
#property indicator_color3 Gold
#property indicator_width1 2
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DASH


#import "fourier extrapolation.dll"
    void fourierExtrapolation(double& source[], double& past[], double& prediction[], int pastBars, int lastBar, int futureBars, int harmonicsNo, double harmonicsTolerance);
#import

//
//
//
//
//

extern int    Price                  = PRICE_CLOSE;
extern int    BarToCalculate         = 1;
extern int    StartAtCycle           = 1;
extern int    UseTopCycles           = 2;
extern bool   UseCosineForWaves      = true;
extern bool   UseAdditionForSteps    = false;
extern int    MaxPer                 = 360;
extern int    WindowSize             = 100;
extern bool   UseCycleList           = true;
extern int    Cycle1                 = 1;
extern int    Cycle2                 = 1;
extern int    Cycle3                 = 1;
extern int    Cycle4                 = 1;
extern int    Cycle5                 = 1;
extern int    Offset                 = 0;
extern bool   SubtractNoise          = false;
extern bool   ListOfCyclesVisible    = false;
extern string ListOfCyclesID         = "GortzelBrowser";
extern int    ListOfCyclesCorner     = 1;
extern color  ListOfCyclesTextColor  = DimGray;
extern color  ListOfCyclesValueColor = PaleVioletRed;

extern int    LastBar                = 1;        // Last bar in the past data
extern int    PastBars               = 100;      // Number of past bars
extern int    FutBars                = 200;      // Number of bars to predict 
extern int    HarmNo                 = 10;       // Number of frequencies; HarmNo=0 computes PastBars harmonics
extern double FreqTOL                = 0.00001;  // Tolerance of frequency calculation - FreqTOL > 0.001 may not converge


double indicatorValues[];
double pastValues[];
double futureValues[];

double source[];
double result[];
double prediction[];

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if(HarmNo==0 || HarmNo>PastBars) HarmNo=PastBars;
      SetIndexBuffer(0,indicatorValues); SetIndexLabel(0,"values");
      SetIndexBuffer(1,pastValues);      SetIndexLabel(1,"past");
      SetIndexBuffer(2,futureValues);    SetIndexLabel(2,"prediction");
   IndicatorShortName("Fourier extrapolation of Goertzel browser");
   return(0);
}
int deinit(){return(0);}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);

      int np = PastBars; if (np>Bars)    np = Bars;
      int nf = FutBars;  if (nf<LastBar) nf = LastBar;

      if (ArraySize(source)    !=np)   ArrayResize(source,np);
      if (ArraySize(result)    !=np)   ArrayResize(result,np);
      if (ArraySize(prediction)!=nf+1) ArrayResize(prediction,nf+1);
               SetIndexShift(1,  -LastBar);
               SetIndexShift(2,nf-LastBar);

      //
      //
      //
      //
      //

      for(int i=limit; i>=0; i--) indicatorValues[i]=iCustom(NULL,0,"Goertzel browser 2",Price,BarToCalculate,StartAtCycle,
      UseTopCycles,UseCosineForWaves,UseAdditionForSteps,MaxPer,WindowSize,UseCycleList,Cycle1,Cycle2,Cycle3,Cycle4,Cycle5,
      Offset,SubtractNoise,ListOfCyclesVisible,ListOfCyclesID,ListOfCyclesCorner,ListOfCyclesTextColor,ListOfCyclesValueColor,0,i);
      
         ArrayCopy(source,indicatorValues,0,LastBar,np);
            fourierExtrapolation(source,result,prediction,np,LastBar,nf+1,HarmNo,FreqTOL);
         ArrayCopy(pastValues,result);
         ArrayCopy(futureValues,prediction);

      //
      //
      //
      //
      //
      
      SetIndexDrawBegin(1,Bars-np-LastBar);
      SetIndexDrawBegin(2,Bars-nf-1);

   return(0); 
}

